#ifndef CUDA_TOOLS_H
#define CUDA_TOOLS_H

// File: s2hat_cuda_tools.cuh
// Created by Ovidiu Hupca, Mikolaj Szydlarski, Giulio Fabbian on 2012-04-26.
// 
// Copyright (C) 2012 Joel Falcou, Laura Grigori, Ovidiu Hupca, Radek Stompor, Mikolaj Szydlarski
// 
// This file is part of S2HAT_CUDA.
// 
// S2HAT_CUDA is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// S2HAT_CUDA is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with S2HAT_CUDA (see 'S2HAT_CUDA_LICENSE.txt' file). 
// If not, see <http://www.gnu.org/licenses/>.

#ifdef __cplusplus
	extern "C" {
#endif

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

#include "s2hat_defs.h"

#ifdef __cplusplus
	}
#endif

#include <cufft.h>
#include <cuda.h>

void Check_CUDA_Error(const char *message);
void Check_CUFFT_Error(cufftResult res, const char *message, int iring);

void printRuntimeParameters();

int selectDevice(int process_id);

#endif